package com.example;

import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

public class C extends AbstractBehavior<C.Message> {

    public interface Message {};

    public record CMessage(int i) implements Message {  }

    public static Behavior<Message> create() {
        return Behaviors.setup(C::new);
    }

    private C(ActorContext<Message> context) {
        super(context);
    }

    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(CMessage.class, this::onCMessage)
                .build();
    }

    private Behavior<Message> onCMessage(CMessage msg) {
        getContext().getLog().info("{}", msg.i);
        return this;
    }
}
