package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

public class GCD extends AbstractBehavior<GCD.Message> {

    public interface Message {};

    public record GCDMessage(int a, int b, ActorRef<C.Message> cust) implements Message {  }

    public static Behavior<Message> create() {
        return Behaviors.setup(GCD::new);
    }

    private GCD(ActorContext<Message> context) {
        super(context);
    }

    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(GCDMessage.class, this::onGCDMessage)
                .build();
    }

    private Behavior<Message> onGCDMessage(GCDMessage msg) {
        if(msg.b == 0) {
            msg.cust.tell(new C.CMessage(msg.a));
        } else {
            this.getContext().getSelf().tell(new GCDMessage(msg.b, msg.a % msg.b, msg.cust));
        }
        return this;
    }
}
